d3.csv('https://gist.githubusercontent.com/curran/a08a1080b88344b0c8a7/raw/0e7a9b0a5d22642a06d3d5b9bcbad9890c8ee534/iris.csv', function(err, rows){
function unpack(rows, key) {
	return rows.map(function(row)
	{ return row[key]; });}
  var colors = []
  var i = 0
    for (i=0; i < unpack(rows, 'species').length; i++) {
      if (unpack(rows, 'species')[i] == "setosa") {
        colors.push(0)
      } else if (unpack(rows, 'species')[i] == "versicolor") {
        colors.push(1)
      } else if (unpack(rows, 'species')[i] == "virginica") {
        colors.push(2)
      }
    }
    var pl_colorscale=[
               [0.0, '#19d3f3'],
               [0.666, '#19d3f3'],
               [0.333, '#e763fa'],
               [0.666, '#e763fa'],
               [0.666, '#636efa'],
               [1, '#636efa']
    ]
var trace1 = {
	x:unpack(rows, 'sepal_length'), 
  y: unpack(rows, 'sepal_width'), 
  z: unpack(rows, 'petal_length'),
	mode: 'markers',
      marker: {
        color: colors,
        colorscale:pl_colorscale,
        size: 12,
        line: {
          color: 'purple',
          width: 0.5
        }
      },
	type: 'scatter3d'
};


var data = [trace1];
var layout = {margin: {
	l: 0,
	r: 0,
	b: 0,
	t: 0
  },
	scene: {
		xaxis:{title: 'Sepal_Length',backgroundcolor: "rgb(180, 180, 180)",
	 gridcolor: "rgb(0, 56, 34)",
	 showbackground: true,
	 zerolinecolor: "rgb(255, 0, 255)"},
		yaxis:{title: 'Sepal Width',
     backgroundcolor: "rgb(80,80,80)",
     gridcolor: "rgb(255, 255, 255)",
     showbackground: true,
     zerolinecolor: "rgb(255, 255, 255)"},
		zaxis:{title: 'Petal Length',
     backgroundcolor: "rgb(144, 144,144)",
     gridcolor: "rgb(255, 255, 255)",
     showbackground: true,
     zerolinecolor: "rgb(255, 255, 255)"},
		}        
  };
Plotly.newPlot('myDiv', data, layout);
});
